#ifdef __PICC__
#include <pic.h>
#endif

#ifdef __PICC18__
#include <pic18.h>
#endif

#include "const.h"
#include "Task_Leds.h"


//------------------------------------------------------------------------------
//     .
//      , . ..  2.
//   ,    
// ---
//   LEDS_COLORS = 1,    ,  ;
//     LEDS_COLORS = 1   #include "Task_Leds.h"
// (.  Task_Leds.h)

#ifndef LEDS_COLORS
    #define LEDS_COLORS    2       
                                   
#endif
//------------------------------------------------------------------------------

#if LEDS_COLORS == 2
    char m_cGreenLeds;
    char m_cRedLeds;
    char m_cFastGreenLeds;
    char m_cFastRedLeds;
    char m_cSlowGreenLeds;
    char m_cSlowRedLeds;
#endif

#if LEDS_COLORS == 1
    char m_cLeds;
    char m_cFastLeds;
    char m_cSlowLeds;
#endif


//------------------------------------------------------------------------------
#ifndef LEDS_INTERVAL
#define LEDS_INTERVAL           30              //   
#endif

#ifndef LEDS_FAST_BLINK_ON
#define LEDS_FAST_BLINK_ON      0x01            //      
#endif

#ifndef LEDS_FAST_BLINK_PERIOD
#define LEDS_FAST_BLINK_PERIOD  0x07            //     
#endif

#ifndef LEDS_SLOW_BLINK_ON
#define LEDS_SLOW_BLINK_ON      0x07            //      
#endif

#ifndef LEDS_SLOW_BLINK_PERIOD
#define LEDS_SLOW_BLINK_PERIOD  0x3F            //     
#endif

//------------------------------------------------------------------------------

#define LEDS_FAST_BLINK_MASK    (LEDS_FAST_BLINK_PERIOD ^ LEDS_FAST_BLINK_ON)
#define LEDS_SLOW_BLINK_MASK    (LEDS_SLOW_BLINK_PERIOD ^ LEDS_SLOW_BLINK_ON)

//------------------------------------------------------------------------------





//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
#ifndef LEDS_TASK_DISABLE
#if LEDS_COLORS == 2
void Task_Leds(void)
{
    static char cLedsCounter;
    char b;


    cLedsCounter = 0;
    
    for (;;)
    {

        OS_Delay(LEDS_INTERVAL ms_OS); // for ...

        //------------------------------------------------------------------------------
        //   
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED0
        if (m_cGreenLeds & 0x01) pin_GREEN_LED0 = 1; else pin_GREEN_LED0 = 0;
        #endif
        #ifdef pin_RED_LED0
        if (m_cRedLeds   & 0x01)   pin_RED_LED0 = 1; else   pin_RED_LED0 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED1
        if (m_cGreenLeds & 0x02) pin_GREEN_LED1 = 1; else pin_GREEN_LED1 = 0;
        #endif
        #ifdef pin_RED_LED1
        if (m_cRedLeds   & 0x02)   pin_RED_LED1 = 1; else   pin_RED_LED1 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED2
        if (m_cGreenLeds & 0x04) pin_GREEN_LED2 = 1; else pin_GREEN_LED2 = 0;
        #endif
        #ifdef pin_RED_LED2
        if (m_cRedLeds   & 0x04)   pin_RED_LED2 = 1; else   pin_RED_LED2 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED3
        if (m_cGreenLeds & 0x08) pin_GREEN_LED3 = 1; else pin_GREEN_LED3 = 0;
        #endif
        #ifdef pin_RED_LED3
        if (m_cRedLeds   & 0x08)   pin_RED_LED3 = 1; else   pin_RED_LED3 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED4
        if (m_cGreenLeds & 0x10) pin_GREEN_LED4 = 1; else pin_GREEN_LED4 = 0;
        #endif
        #ifdef pin_RED_LED4
        if (m_cRedLeds   & 0x10)   pin_RED_LED4 = 1; else   pin_RED_LED4 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED5
        if (m_cGreenLeds & 0x20) pin_GREEN_LED5 = 1; else pin_GREEN_LED5 = 0;
        #endif
        #ifdef pin_RED_LED5
        if (m_cRedLeds   & 0x20)   pin_RED_LED5 = 1; else   pin_RED_LED5 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED6
        if (m_cGreenLeds & 0x40) pin_GREEN_LED6 = 1; else pin_GREEN_LED6 = 0;
        #endif
        #ifdef pin_RED_LED6
        if (m_cRedLeds   & 0x40)   pin_RED_LED6 = 1; else   pin_RED_LED6 = 0;
        #endif

        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED7
        if (m_cGreenLeds & 0x80) pin_GREEN_LED7 = 1; else pin_GREEN_LED7 = 0;
        #endif
        #ifdef pin_RED_LED7
        if (m_cRedLeds   & 0x80)   pin_RED_LED7 = 1; else   pin_RED_LED7 = 0;
        #endif
        
        //------------------------------------------------------------------------------
        if (!(cLedsCounter & LEDS_SLOW_BLINK_MASK))          //    
        {
            #if defined (pin_GREEN_LED0) || defined (pin_RED_LED0)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x01) {
                #ifdef pin_GREEN_LED0
                if (m_cSlowGreenLeds & 0x01) pin_GREEN_LED0 = 1; else pin_GREEN_LED0 = 0;
                #endif
                #ifdef pin_RED_LED0
                if (m_cSlowRedLeds   & 0x01)   pin_RED_LED0 = 1; else   pin_RED_LED0 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED1) || defined (pin_RED_LED1)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x02) {
                #ifdef pin_GREEN_LED1
                if (m_cSlowGreenLeds & 0x02) pin_GREEN_LED1 = 1; else pin_GREEN_LED1 = 0;
                #endif
                #ifdef pin_RED_LED1
                if (m_cSlowRedLeds   & 0x02)   pin_RED_LED1 = 1; else   pin_RED_LED1 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED2) || defined (pin_RED_LED2)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x04) {
                #ifdef pin_GREEN_LED2
                if (m_cSlowGreenLeds & 0x04) pin_GREEN_LED2 = 1; else pin_GREEN_LED2 = 0;
                #endif
                #ifdef pin_RED_LED2
                if (m_cSlowRedLeds   & 0x04)   pin_RED_LED2 = 1; else   pin_RED_LED2 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED3) || defined (pin_RED_LED3)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x08) {
                #ifdef pin_GREEN_LED3
                if (m_cSlowGreenLeds & 0x08) pin_GREEN_LED3 = 1; else pin_GREEN_LED3 = 0;
                #endif
                #ifdef pin_RED_LED3
                if (m_cSlowRedLeds   & 0x08)   pin_RED_LED3 = 1; else   pin_RED_LED3 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED4) || defined (pin_RED_LED4)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x10) {
                #ifdef pin_GREEN_LED4
                if (m_cSlowGreenLeds & 0x10) pin_GREEN_LED4 = 1; else pin_GREEN_LED4 = 0;
                #endif
                #ifdef pin_RED_LED4
                if (m_cSlowRedLeds   & 0x10)   pin_RED_LED4 = 1; else   pin_RED_LED4 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED5) || defined (pin_RED_LED5)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x20) {
                #ifdef pin_GREEN_LED5
                if (m_cSlowGreenLeds & 0x20) pin_GREEN_LED5 = 1; else pin_GREEN_LED5 = 0;
                #endif
                #ifdef pin_RED_LED5
                if (m_cSlowRedLeds   & 0x20)   pin_RED_LED5 = 1; else   pin_RED_LED5 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED6) || defined (pin_RED_LED6)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x40) {
                #ifdef pin_GREEN_LED6
                if (m_cSlowGreenLeds & 0x40) pin_GREEN_LED6 = 1; else pin_GREEN_LED6 = 0;
                #endif
                #ifdef pin_RED_LED6
                if (m_cSlowRedLeds   & 0x40)   pin_RED_LED6 = 1; else   pin_RED_LED6 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED7) || defined (pin_RED_LED7)
            if ((m_cSlowGreenLeds | m_cSlowRedLeds) & 0x80) {
                #ifdef pin_GREEN_LED7
                if (m_cSlowGreenLeds & 0x80) pin_GREEN_LED7 = 1; else pin_GREEN_LED7 = 0;
                #endif
                #ifdef pin_RED_LED7
                if (m_cSlowRedLeds   & 0x80)   pin_RED_LED7 = 1; else   pin_RED_LED7 = 0;
                #endif
            }
            #endif

        }
        //------------------------------------------------------------------------------
        if (!(cLedsCounter & LEDS_FAST_BLINK_MASK))     //    
        {
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED0) || defined (pin_RED_LED0)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x01) {
                #ifdef pin_GREEN_LED0
                if (m_cFastGreenLeds & 0x01) pin_GREEN_LED0 = 1; else pin_GREEN_LED0 = 0;
                #endif
                #ifdef pin_RED_LED0
                if (m_cFastRedLeds   & 0x01)   pin_RED_LED0 = 1; else   pin_RED_LED0 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED1) || defined (pin_RED_LED1)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x02) {
                #ifdef pin_GREEN_LED1
                if (m_cFastGreenLeds & 0x02) pin_GREEN_LED1 = 1; else pin_GREEN_LED1 = 0;
                #endif
                #ifdef pin_RED_LED1
                if (m_cFastRedLeds   & 0x02)   pin_RED_LED1 = 1; else   pin_RED_LED1 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED2) || defined (pin_RED_LED2)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x04) {
                #ifdef pin_GREEN_LED2
                if (m_cFastGreenLeds & 0x04) pin_GREEN_LED2 = 1; else pin_GREEN_LED2 = 0;
                #endif
                #ifdef pin_RED_LED2
                if (m_cFastRedLeds   & 0x04)   pin_RED_LED2 = 1; else   pin_RED_LED2 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED3) || defined (pin_RED_LED3)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x08) {
                #ifdef pin_GREEN_LED3
                if (m_cFastGreenLeds & 0x08) pin_GREEN_LED3 = 1; else pin_GREEN_LED3 = 0;
                #endif
                #ifdef pin_RED_LED3
                if (m_cFastRedLeds   & 0x08)   pin_RED_LED3 = 1; else   pin_RED_LED3 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED4) || defined (pin_RED_LED4)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x10) {
                #ifdef pin_GREEN_LED4
                if (m_cFastGreenLeds & 0x10) pin_GREEN_LED4 = 1; else pin_GREEN_LED4 = 0;
                #endif
                #ifdef pin_RED_LED4
                if (m_cFastRedLeds   & 0x10)   pin_RED_LED4 = 1; else   pin_RED_LED4 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED5) || defined (pin_RED_LED5)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x20) {
                #ifdef pin_GREEN_LED5
                if (m_cFastGreenLeds & 0x20) pin_GREEN_LED5 = 1; else pin_GREEN_LED5 = 0;
                #endif
                #ifdef pin_RED_LED5
                if (m_cFastRedLeds   & 0x20)   pin_RED_LED5 = 1; else   pin_RED_LED5 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED6) || defined (pin_RED_LED6)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x40) {
                #ifdef pin_GREEN_LED6
                if (m_cFastGreenLeds & 0x40) pin_GREEN_LED6 = 1; else pin_GREEN_LED6 = 0;
                #endif
                #ifdef pin_RED_LED6
                if (m_cFastRedLeds   & 0x40)   pin_RED_LED6 = 1; else   pin_RED_LED6 = 0;
                #endif
            }
            #endif
            //------------------------------------------------------------------------------
            #if defined (pin_GREEN_LED7) || defined (pin_RED_LED7)
            if ((m_cFastGreenLeds | m_cFastRedLeds) & 0x80) {
                #ifdef pin_GREEN_LED7
                if (m_cFastGreenLeds & 0x80) pin_GREEN_LED7 = 1; else pin_GREEN_LED7 = 0;
                #endif
                #ifdef pin_RED_LED7
                if (m_cFastRedLeds   & 0x80)   pin_RED_LED7 = 1; else   pin_RED_LED7 = 0;
                #endif
            }
            #endif
        }

        //------------------------------------------------------------------------------
        //    
        b = m_cGreenLeds | m_cFastGreenLeds | m_cSlowGreenLeds;
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED0
        if(!(b & 1))    pin_GREEN_LED0 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED1
        if(!(b & 2))    pin_GREEN_LED1 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED2
        if(!(b & 4))    pin_GREEN_LED2 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED3
        if(!(b & 8))    pin_GREEN_LED3 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED4
        if(!(b & 16))   pin_GREEN_LED4 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED5
        if(!(b & 32))   pin_GREEN_LED5 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED6
        if(!(b & 64))   pin_GREEN_LED6 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_GREEN_LED7
        if(!(b & 128))  pin_GREEN_LED7 = 0;
        #endif
        
        //------------------------------------------------------------------------------
        b = m_cRedLeds | m_cFastRedLeds | m_cSlowRedLeds;
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED0
        if(!(b & 1))    pin_RED_LED0 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED1
        if(!(b & 2))    pin_RED_LED1 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED2
        if(!(b & 4))    pin_RED_LED2 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED3
        if(!(b & 8))    pin_RED_LED3 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED4
        if(!(b & 16))   pin_RED_LED4 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED5
        if(!(b & 32))   pin_RED_LED5 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED6
        if(!(b & 64))   pin_RED_LED6 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_RED_LED7
        if(!(b & 128))  pin_RED_LED7 = 0;
        #endif


        cLedsCounter ++;
//        if (cLedsCounter >= 32) cLedsCounter = 0;
    }
}
#endif   // LEDS_COLORS == 2
#endif   // #ifndef LEDS_TASK_DISABLE
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
#ifndef LEDS_TASK_DISABLE
#if LEDS_COLORS == 1
void Task_Leds(void)
{
    static char cLedsCounter;
    char b;


    cLedsCounter = 0;
    
    for (;;)
    {

        OS_Delay(LEDS_INTERVAL ms_OS); // for ...

        //------------------------------------------------------------------------------
        //   
        //------------------------------------------------------------------------------
        #ifdef pin_LED0
        if (m_cLeds & 0x01) pin_LED0 = 1; else pin_LED0 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED1
        if (m_cLeds & 0x02) pin_LED1 = 1; else pin_LED1 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED2
        if (m_cLeds & 0x04) pin_LED2 = 1; else pin_LED2 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED3
        if (m_cLeds & 0x08) pin_LED3 = 1; else pin_LED3 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED4
        if (m_cLeds & 0x10) pin_LED4 = 1; else pin_LED4 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED5
        if (m_cLeds & 0x20) pin_LED5 = 1; else pin_LED5 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED6
        if (m_cLeds & 0x40) pin_LED6 = 1; else pin_LED6 = 0;
        #endif
        //------------------------------------------------------------------------------
        #ifdef pin_LED7
        if (m_cLeds & 0x80) pin_LED7 = 1; else pin_LED7 = 0;
        #endif
        //------------------------------------------------------------------------------
        
        //------------------------------------------------------------------------------
        if (!(cLedsCounter & LEDS_SLOW_BLINK_MASK))          //    
        {
            //------------------------------------------------------------------------------
            #ifdef pin_LED0
            if (m_cSlowLeds & 0x01) pin_LED0 = 1;// else pin_LED0 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED1
            if (m_cSlowLeds & 0x02) pin_LED1 = 1;// else pin_LED1 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED2
            if (m_cSlowLeds & 0x04) pin_LED2 = 1;// else pin_LED2 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED3
            if (m_cSlowLeds & 0x08) pin_LED3 = 1;// else pin_LED3 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED4
            if (m_cSlowLeds & 0x10) pin_LED4 = 1;// else pin_LED4 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED5
            if (m_cSlowLeds & 0x20) pin_LED5 = 1;// else pin_LED5 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED6
            if (m_cSlowLeds & 0x40) pin_LED6 = 1;// else pin_LED6 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED7
            if (m_cSlowLeds & 0x80) pin_LED7 = 1;// else pin_LED7 = 0;
            #endif
            //------------------------------------------------------------------------------
        }
        //------------------------------------------------------------------------------
        if (!(cLedsCounter & LEDS_FAST_BLINK_MASK))     //    
        {
            //------------------------------------------------------------------------------
            #ifdef pin_LED0
            if (m_cFastLeds & 0x01) pin_LED0 = 1;// else pin_LED0 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED1
            if (m_cFastLeds & 0x02) pin_LED1 = 1;// else pin_LED1 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED2
            if (m_cFastLeds & 0x04) pin_LED2 = 1;// else pin_LED2 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED3
            if (m_cFastLeds & 0x08) pin_LED3 = 1;// else pin_LED3 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED4
            if (m_cFastLeds & 0x10) pin_LED4 = 1;// else pin_LED4 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED5
            if (m_cFastLeds & 0x20) pin_LED5 = 1;// else pin_LED5 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED6
            if (m_cFastLeds & 0x40) pin_LED6 = 1;// else pin_LED6 = 0;
            #endif
            //------------------------------------------------------------------------------
            #ifdef pin_LED7
            if (m_cFastLeds & 0x80) pin_LED7 = 1;// else pin_LED7 = 0;
            #endif
            //------------------------------------------------------------------------------
        }

        //------------------------------------------------------------------------------
        //    
        b = m_cLeds | m_cFastLeds | m_cSlowLeds;
        //------------------------------------------------------------------------------
        #ifdef pin_LED0
        if(!(b & 1))    pin_LED0 = 0;
        #endif
        #ifdef pin_LED1
        if(!(b & 2))    pin_LED1 = 0;
        #endif
        #ifdef pin_LED2
        if(!(b & 4))    pin_LED2 = 0;
        #endif
        #ifdef pin_LED3
        if(!(b & 8))    pin_LED3 = 0;
        #endif
        #ifdef pin_LED4
        if(!(b & 16))    pin_LED4 = 0;
        #endif
        #ifdef pin_LED5
        if(!(b & 32))    pin_LED5 = 0;
        #endif
        #ifdef pin_LED6
        if(!(b & 64))    pin_LED6 = 0;
        #endif
        #ifdef pin_LED7
        if(!(b & 128))    pin_LED7 = 0;
        #endif


        cLedsCounter ++;
//        if (cLedsCounter >= 32) cLedsCounter = 0;
    }
}

#endif
#endif // #ifndef LEDS_TASK_DISABLE
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
/*
 *   
 */
#if LEDS_COLORS == 2
void SetLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & CL_GREEN) m_cGreenLeds |= cNum;
    if (!(cl & CL_GREEN)) m_cGreenLeds &= ~cNum;
    if (cl & CL_RED) m_cRedLeds |= cNum;
    if (!(cl & CL_RED)) m_cRedLeds &= ~cNum;
    
    m_cFastGreenLeds &= ~cNum;
    m_cFastRedLeds &= ~cNum;
    m_cSlowGreenLeds &= ~cNum;
    m_cSlowRedLeds &= ~cNum;
}
/*
 *    
 */
void SetFastLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & CL_GREEN)      m_cFastGreenLeds |= cNum;
    if (!(cl & CL_GREEN))   m_cFastGreenLeds &= ~cNum;
    if (cl & CL_RED)        m_cFastRedLeds |= cNum;
    if (!(cl & CL_RED))     m_cFastRedLeds &= ~cNum;
    
    m_cGreenLeds &= ~cNum;
    m_cRedLeds &= ~cNum;
    m_cSlowGreenLeds &= ~cNum;
    m_cSlowRedLeds &= ~cNum;
}
/*
 *    
 */
void SetSlowLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & CL_GREEN)      m_cSlowGreenLeds |= cNum;
    if (!(cl & CL_GREEN))   m_cSlowGreenLeds &= ~cNum;
    if (cl & CL_RED)        m_cSlowRedLeds |= cNum;
    if (!(cl & CL_RED))     m_cSlowRedLeds &= ~cNum;
    
    m_cFastGreenLeds &= ~cNum;
    m_cFastRedLeds &= ~cNum;
    m_cGreenLeds &= ~cNum;
    m_cRedLeds &= ~cNum;
}

/*
 *   
 */

void AllLedsOff (void)
{
    m_cSlowGreenLeds = 0;
    m_cSlowRedLeds = 0;
    m_cFastGreenLeds = 0;
    m_cFastRedLeds = 0;
    m_cGreenLeds = 0;
    m_cRedLeds = 0;
}

#endif // LEDS_COLORS == 2


//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
#if LEDS_COLORS == 1

#ifdef LEDS_MACRO_ENABLE
char cNum, cl;

void LedsPrepare (void)
{
#ifdef __OSAPICC__
    asm("\t    clrf     _STATUS     ");
#endif
#ifdef __OSAPICC18__
    asm("\t    movlb    high(_cl)     ");
#endif
    asm("\t    movwf    _cl     ");
    asm("\t    bcf      _cl,0      ");
    asm("\t    btfss    _cl, 7     ");    
    asm("\t    btfsc    _cl, 6     ");
    asm("\t    bsf      _cl, 0     ");
    
#ifdef __OSAPICC18__
    asm("\t    movlb    high(_cNum)     ");
#endif
    asm("\t    andlw    0x3F     ");
    asm("\t    clrf     _cNum     ");
    asm("\t    bsf      _cNum, 0     ");
    asm("\tLOOP:         ");
    asm("\t    addlw    -1     ");
    asm("\t    btfss    _STATUS, 0     ");
    asm("\t    return     ");
#ifdef __OSAPICC18__
    asm("\t    rlncf      _cNum, f     ");
#endif
#ifdef __OSAPICC__
    asm("\t    bcf      _STATUS, 0     ");
    asm("\t    rlf      _cNum, f     ");
#endif
    asm("\t    goto     LOOP     ");
}


//------------------------------------------------------------------------------
void _SetLed (char cInfo)
{
    LedsPrepare();
    if ( (cl & 1)) m_cLeds |= cNum;
    if (!(cl & 1)) m_cLeds &= ~cNum;
    
    m_cFastLeds &= ~cNum;
    m_cSlowLeds &= ~cNum;
}

//------------------------------------------------------------------------------
void _SetFastLed (char cInfo)
{
    LedsPrepare();
    if ( (cl & 1)) m_cFastLeds |= cNum;
    if (!(cl & 1)) m_cFastLeds &= ~cNum;
    
    m_cLeds &= ~cNum;
    m_cSlowLeds &= ~cNum;
}
//------------------------------------------------------------------------------
void _SetSlowLed (char cInfo)
{
    LedsPrepare();
    if ( (cl & 1)) m_cSlowLeds |= cNum;
    if (!(cl & 1)) m_cSlowLeds &= ~cNum;
    
    m_cFastLeds &= ~cNum;
    m_cSlowLeds &= ~cNum;
}

#else       // LEDS_MACRO_ENABLE

void SetLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & 0x2) cl |= 0x1;
    if ( (cl & 1)) m_cLeds |= cNum;
    if (!(cl & 1)) m_cLeds &= ~cNum;
    
    m_cFastLeds &= ~cNum;
    m_cSlowLeds &= ~cNum;
}
/*
 *    
 */
void SetFastLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & 0x2) cl |= 0x1;
    if ( (cl & 1)) m_cFastLeds |= cNum;
    if (!(cl & 1)) m_cFastLeds &= ~cNum;
    
    m_cLeds &= ~cNum;
    m_cSlowLeds &= ~cNum;
}
/*
 *    
 */
void SetSlowLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & 0x2) cl |= 0x1;
    if ( (cl & 1)) m_cSlowLeds |= cNum;
    if (!(cl & 1)) m_cSlowLeds &= ~cNum;
    
    m_cFastLeds &= ~cNum;
    m_cSlowLeds &= ~cNum;
}

#endif  // LEDS_MACRO_ENABLE


void AllLedsOff (void)
{
    m_cSlowLeds = 0;
    m_cFastLeds = 0;
    m_cLeds = 0;
}


#endif // LEDS_COLORS == 1

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

#if LEDS_COLORS >= 2
#ifndef LEDS_ADD_FUNCTION_ABSENT

/*
 *    (  )
 */
void AddLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & CL_GREEN)
    {
        m_cGreenLeds |= cNum;
    }
    if (cl & CL_RED)
    {
        m_cRedLeds |= cNum;
    }
}
/*
 *     (  )
 */
void AddFastLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & CL_GREEN)
    {
        m_cFastGreenLeds |= cNum;
    }
    if (cl & CL_RED)
    {
        m_cFastRedLeds |= cNum;
    }
}
/*
 *    (  )
 */
void AddSlowLed (char cNum, char cl)
{
    cNum = 1 << cNum;
    if (cl & CL_GREEN)
    {
        m_cSlowGreenLeds |= cNum;
    }
    if (cl & CL_RED)
    {
        m_cSlowRedLeds |= cNum;
    }
}

#endif // LEDS_ADD_FUNCTION_ABSENT

#endif // LEDS_COLORS >= 2
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
